//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2018, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property strict
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//INPUTS
input int iPeriod = 12;
input color TEXT_COLOR = clrYellow;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int PERIOD;
double BuySignal[];
double SellSignals[];
double Sell_CalculationBuffer[];
double Buy_CalculationBuffer[];
double PriceUpper[];
double gd_80 = 1.2;
int init()
  {
   PERIOD= iPeriod;
   if(PERIOD < 2)
      PERIOD = 2;
   IndicatorBuffers(7);
   SetIndexBuffer(0, BuySignal);
   SetIndexBuffer(1, SellSignals);
   SetIndexBuffer(4, Sell_CalculationBuffer);
   SetIndexBuffer(5, Buy_CalculationBuffer);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(6, PriceUpper);
   SetIndexLabel(0, "MaPeriod ");
   SetIndexLabel(0, "MaPeriod ");
   SetIndexShift(0, -1);
   SetIndexShift(1, -1);
   SetIndexEmptyValue(0, 0);
   SetIndexEmptyValue(1, 0);
   IndicatorDigits(Digits);
   IndicatorShortName("MaPeriod (" + (string)PERIOD + ")");
   SetIndexLabel(0, "1");
   SetIndexLabel(1, "2");
   SetIndexDrawBegin(0, PERIOD - 1);
   SetIndexDrawBegin(1, PERIOD - 1);
   gd_80 /= 100.0;
   return (0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deinit()
  {
   ObjectDelete("Text_SIGNAL");
   WindowRedraw();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int PrewBars;
   if(Bars <= PERIOD)
      return (0);
   int CountedBars = IndicatorCounted();
   if(CountedBars < 0)
      return (-1);
   if(CountedBars == 0)
     {
      PrewBars = Bars - PERIOD - 1;
      for(int i = 0; i < Bars; i++)
        {
         BuySignal[i] = 0;
         SellSignals[i] = 0;
        }
     }
   else
      PrewBars = Bars - CountedBars - 1;
   for(int i = PrewBars; i > 0; i--)
     {
      Sell_CalculationBuffer[i] = (gd_80 / 100.0 + 1.0) * iMA(NULL, 0, PERIOD, 0, MODE_SMA, PRICE_CLOSE, i);
      Buy_CalculationBuffer[i] = (1 - gd_80 / 100.0) * iMA(NULL, 0, PERIOD, 0, MODE_SMA, PRICE_CLOSE, i);
      PriceUpper[i] = PriceUpper[i + 1];
      if(Close[i] > Sell_CalculationBuffer[i + 1])
         PriceUpper[i] = 1;
      if(Close[i] < Buy_CalculationBuffer[i + 1])
         PriceUpper[i] = -1;
      if(PriceUpper[i] > 0.0)
        {
         if(Buy_CalculationBuffer[i] < Buy_CalculationBuffer[i + 1])
            Buy_CalculationBuffer[i] = Buy_CalculationBuffer[i + 1];
         BuySignal[i] = Buy_CalculationBuffer[i];
         SellSignals[i] = 0;
        }
      else
        {
         if(Sell_CalculationBuffer[i] > Sell_CalculationBuffer[i + 1])
            Sell_CalculationBuffer[i] = Sell_CalculationBuffer[i + 1];
         SellSignals[i] = Sell_CalculationBuffer[i];
         BuySignal[i] = 0;
        }
     }
   string Text = "";
   if(BuySignal[1] > 0.0)
      Text = "LATEST SIGNAL: BUY - TREND BULLISH";
   if(SellSignals[1] > 0.0)
      Text = "LATEST SIGNAL: SELL - TREND BEARISH";
   DrawText("Text_SIGNAL", Text, TEXT_COLOR, X, Y, CORNER);
   return (0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int X = 10;
int Y = 10;
int CORNER = 3;
string FONT_NAME = "Courier New";
int FONT_SIZE = 12;
void DrawText(string a_name_0, string a_text_8, color a_color_16, int a_x_20, int a_y_24, int a_corner_28)
  {
   if(ObjectFind(a_name_0) == 0 || ObjectCreate(a_name_0, OBJ_LABEL, 0, 0, 0))
     {
      ObjectSet(a_name_0, OBJPROP_COLOR, a_color_16);
      ObjectSet(a_name_0, OBJPROP_XDISTANCE, a_x_20);
      ObjectSet(a_name_0, OBJPROP_YDISTANCE, a_y_24);
      ObjectSet(a_name_0, OBJPROP_CORNER, a_corner_28);
      ObjectSet(a_name_0, OBJPROP_FONTSIZE, FONT_SIZE);
      ObjectSetText(a_name_0, a_text_8, FONT_SIZE, FONT_NAME);
     }
  }
//+------------------------------------------------------------------+
